Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ForwardingSortedSet<E>

    java.lang.Object
      com.google.common.collect.ForwardingObject
          com.google.common.collect.ForwardingCollection<E>
              com.google.common.collect.ForwardingSet<E>
                  com.google.common.collect.ForwardingSortedSet<E>

All Implemented Interfaces:
  Iterable<E>, Collection<E>, Set<E>, SortedSet<E>

    @GwtCompatible
    public abstract class ForwardingSortedSet<E>

extends ForwardingSet<E>
implements SortedSet<E>

A sorted set which forwards all its method calls to another sorted set. Subclasses should override one or more methods to modify the behavior of the backing sorted set as desired per the decorator pattern.

Warning: The methods of `ForwardingSortedSet` forward indiscriminately to the methods of the delegate. For example, overriding `ForwardingCollection.add(E)` alone will not change the behavior of `ForwardingCollection.addAll(java.util.Collection)`, which can lead to unexpected behavior. In this case, you should override `addAll` as well, either providing your own implementation, or delegating to the provided `standardAddAll` method.

Each of the `standard` methods, where appropriate, uses the set's comparator (or the natural ordering of the elements, if there is no comparator) to test element equality. As a result, if the comparator is not consistent with equals, some of the standard implementations may violate the `Set` contract.

The `standard` methods and the collection views they return are not guaranteed to be thread-safe, even when all of the methods that they depend on are thread-safe.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Mike Bostock, Louis Wasserman

Constructor Summary
`protected` | `ForwardingSortedSet()` Constructor for use by subclasses.

Method Summary
`Comparator<? super E>` | `comparator()`
`protected abstract SortedSet<E>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
`E` | `first()`
`SortedSet<E>` | `headSet(E toElement)`
`E` | `last()`
`protected boolean` | `standardContains(Object object)` A sensible definition of `ForwardingCollection.contains(java.lang.Object)` in terms of the `first()` method of `tailSet(E)`.
`protected boolean` | `standardRemove(Object object)` A sensible definition of `ForwardingCollection.remove(java.lang.Object)` in terms of the `iterator()` method of `tailSet(E)`.
`protected SortedSet<E>` | `standardSubSet(E fromElement, E toElement)` A sensible default implementation of `subSet(Object, Object)` in terms of `headSet(Object)` and `tailSet(Object)`.
`SortedSet<E>` | `subSet(E fromElement, E toElement)`
`SortedSet<E>` | `tailSet(E fromElement)`

Methods inherited from class com.google.common.collect.ForwardingSet
`equals, hashCode, standardEquals, standardHashCode`

Methods inherited from class com.google.common.collect.ForwardingCollection
`add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, standardAddAll, standardClear, standardContainsAll, standardIsEmpty, standardRemoveAll, standardRetainAll, standardToArray, standardToArray, standardToString, toArray, toArray`

Methods inherited from class com.google.common.collect.ForwardingObject
`toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Set
`add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

Constructor Detail

### ForwardingSortedSet

    protected ForwardingSortedSet()

  Constructor for use by subclasses.

Method Detail

### delegate

    protected abstract SortedSet<E> delegate()

  Description copied from class: `ForwardingObject`
  Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.

  Specified by:
    `delegate` in class `ForwardingSet<E>`

### comparator

    public Comparator<? super E> comparator()

  Specified by:
    `comparator` in interface `SortedSet<E>`

### first

    public E first()

  Specified by:
    `first` in interface `SortedSet<E>`

### headSet

    public SortedSet<E> headSet(E toElement)

  Specified by:
    `headSet` in interface `SortedSet<E>`

### last

    public E last()

  Specified by:
    `last` in interface `SortedSet<E>`

### subSet

    public SortedSet<E> subSet(E fromElement,
                               E toElement)

  Specified by:
    `subSet` in interface `SortedSet<E>`

### tailSet

    public SortedSet<E> tailSet(E fromElement)

  Specified by:
    `tailSet` in interface `SortedSet<E>`

### standardContains

    @Beta
    protected boolean standardContains(@Nullable
                                            Object object)

  A sensible definition of `ForwardingCollection.contains(java.lang.Object)` in terms of the `first()` method of `tailSet(E)`. If you override `tailSet(E)`, you may wish to override `ForwardingCollection.contains(java.lang.Object)` to forward to this implementation.

  Overrides:
    `standardContains` in class `ForwardingCollection<E>`
  Since:
    7.0

### standardRemove

    @Beta
    protected boolean standardRemove(@Nullable
                                          Object object)

  A sensible definition of `ForwardingCollection.remove(java.lang.Object)` in terms of the `iterator()` method of `tailSet(E)`. If you override `tailSet(E)`, you may wish to override `ForwardingCollection.remove(java.lang.Object)` to forward to this implementation.

  Overrides:
    `standardRemove` in class `ForwardingCollection<E>`
  Since:
    7.0

### standardSubSet

    @Beta
    protected SortedSet<E> standardSubSet(E fromElement,
                                               E toElement)

  A sensible default implementation of `subSet(Object, Object)` in terms of `headSet(Object)` and `tailSet(Object)`. In some situations, you may wish to override `subSet(Object, Object)` to forward to this implementation.

  Since:
    7.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.